namespace com.progsbase.no.inductive.idea10.programs.Graphics2D_v0_2_0{

using static System.Math;

public class RGBA{
	public double r;
	public double g;
	public double b;
	public double a;
}
public class RGBABitmap{
	public RGBA [] y;
}
public class RGBABitmapImage{
	public RGBABitmap [] x;
}
public class Graphics2D{
	public static RGBA getBlack(){
		RGBA black;
		black = new RGBA();
		black.a = 1d;
		black.r = 0d;
		black.g = 0d;
		black.b = 0d;
		return black;
	}


	public static RGBA getWhite(){
		RGBA white;
		white = new RGBA();
		white.a = 1d;
		white.r = 1d;
		white.g = 1d;
		white.b = 1d;
		return white;
	}


	public static RGBABitmapImage createImage(double w, double h, RGBA color){
		RGBABitmapImage image;
		double i, j;
		image = new RGBABitmapImage();
		image.x = new RGBABitmap [(int)(w)];
		for(i = 0d; i < w; i = i + 1d){
			image.x[(int)(i)] = new RGBABitmap();
			image.x[(int)(i)].y = new RGBA [(int)(h)];
			for(j = 0d; j < h; j = j + 1d){
				image.x[(int)(i)].y[(int)(j)] = new RGBA();
				dp(image, i, j, color);
			}
		}

		return image;
	}


	public static void dp(RGBABitmapImage image, double x, double y, RGBA color){
		image.x[(int)(x)].y[(int)(y)].a = color.a;
		image.x[(int)(x)].y[(int)(y)].r = color.r;
		image.x[(int)(x)].y[(int)(y)].g = color.g;
		image.x[(int)(x)].y[(int)(y)].b = color.b;
	}


	public static void drawHorizontalLine1px(RGBABitmapImage image, double x, double y, double length, RGBA color){
		double i;
		for(i = 0d; i < length; i = i + 1d){
			dp(image, x + i, y, color);
		}
	}


	public static void drawVerticalLine1px(RGBABitmapImage image, double x, double y, double height, RGBA color){
		double i;
		for(i = 0d; i < height; i = i + 1d){
			dp(image, x, y + i, color);
		}
	}


	public static void drawRectangle1px(RGBABitmapImage image, double x, double y, double height, double width, RGBA color){
		drawHorizontalLine1px(image, x, y, width, color);
		drawVerticalLine1px(image, x, y, height, color);
		drawHorizontalLine1px(image, x, y + height, width, color);
		drawVerticalLine1px(image, x + width, y, height, color);
	}


	public static void delete(System.Object objectx){
		// C# has garbage collection.
	}
}

}